using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace CSharpDemo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private ZylTimer.Timer timerZyl;
		private System.Windows.Forms.Timer timerMain;
		private System.Windows.Forms.Timer timerDotNet;
		private System.Windows.Forms.Button btnStart;
		private System.Windows.Forms.Button btnStop;
		private System.Windows.Forms.TextBox textBoxOut;
		private System.ComponentModel.IContainer components;
		public int DotNetCounter = 0;		
		public int ZylCounter = 0;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.label1 = new System.Windows.Forms.Label();
			this.textBoxOut = new System.Windows.Forms.TextBox();
			this.btnStart = new System.Windows.Forms.Button();
			this.btnStop = new System.Windows.Forms.Button();
			this.timerZyl = new ZylTimer.Timer(this.components);
			this.timerMain = new System.Windows.Forms.Timer(this.components);
			this.timerDotNet = new System.Windows.Forms.Timer(this.components);
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(8, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(272, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "Tick events in 1 second (.NET Timer/ZylTimer):";
			// 
			// textBoxOut
			// 
			this.textBoxOut.Location = new System.Drawing.Point(8, 40);
			this.textBoxOut.Multiline = true;
			this.textBoxOut.Name = "textBoxOut";
			this.textBoxOut.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBoxOut.Size = new System.Drawing.Size(280, 152);
			this.textBoxOut.TabIndex = 1;
			this.textBoxOut.Text = "";
			// 
			// btnStart
			// 
			this.btnStart.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnStart.Location = new System.Drawing.Point(8, 208);
			this.btnStart.Name = "btnStart";
			this.btnStart.TabIndex = 2;
			this.btnStart.Text = "Start";
			this.btnStart.Click += new System.EventHandler(this.btnStart_Click);
			// 
			// btnStop
			// 
			this.btnStop.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnStop.Location = new System.Drawing.Point(104, 208);
			this.btnStop.Name = "btnStop";
			this.btnStop.TabIndex = 3;
			this.btnStop.Text = "Stop";
			this.btnStop.Click += new System.EventHandler(this.btnStop_Click);
			// 
			// timerZyl
			// 
			this.timerZyl.Cycled = true;
			this.timerZyl.Enabled = false;
			this.timerZyl.Interval = 1;
			this.timerZyl.Priority = System.Threading.ThreadPriority.Normal;
			this.timerZyl.RepeatCount = 0;
			this.timerZyl.Tick += new ZylTimer.TickEventHandler(this.timerZyl_Tick);
			// 
			// timerMain
			// 
			this.timerMain.Interval = 1000;
			this.timerMain.Tick += new System.EventHandler(this.timerMain_Tick);
			// 
			// timerDotNet
			// 
			this.timerDotNet.Interval = 1;
			this.timerDotNet.Tick += new System.EventHandler(this.timerDotNet_Tick);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(296, 238);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.btnStop,
																		  this.btnStart,
																		  this.textBoxOut,
																		  this.label1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "ZylTimer.NET Demo";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.Closed += new System.EventHandler(this.Form1_Closed);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
		
		}

		private void btnStart_Click(object sender, System.EventArgs e)
		{
			timerDotNet.Enabled = true;
			timerZyl.Enabled = true;
			timerMain.Enabled = true;
		}

		private void btnStop_Click(object sender, System.EventArgs e)
		{
			timerDotNet.Enabled = false;
			timerZyl.Enabled = false;
			timerMain.Enabled = false;
			ZylCounter = 0;
			DotNetCounter = 0;
		}

		private void Form1_Closed(object sender, System.EventArgs e)
		{
			if (timerZyl != null)
				timerZyl.Stop();
		}

		private void timerMain_Tick(object sender, System.EventArgs e)
		{
			textBoxOut.Text += DotNetCounter.ToString() + " / " +
				ZylCounter.ToString() + Environment.NewLine;
			textBoxOut.SelectionStart = textBoxOut.Text.Length;
			textBoxOut.SelectionLength = 0;
			textBoxOut.ScrollToCaret();
			ZylCounter = 0;
			DotNetCounter = 0;
		}

		private void timerZyl_Tick(object sender, System.EventArgs e)
		{
			ZylCounter++;
		}

		private void timerDotNet_Tick(object sender, System.EventArgs e)
		{
			DotNetCounter++;
		}

	}
}
